#!/usr/bin/env batchflow
<?xml version="1.0"?>
<Document>
  <Network type="subnet" name="MAIN">
    <Node name="node_LOOP0_1" type="LOOP0" x="-58.000000" y="28.000000">
      <Parameter name="LENGTH" type="subnet_param" value="int:ARG2" description="window length in sample [default: 512]"/>
      <Parameter name="ADVANCE" type="subnet_param" value="int:ARG3" description="The length in sample between a frame and a previous frame. [default: 160]"/>
      <Parameter name="SAMPLING_RATE" type="subnet_param" value="int:ARG4" description="Sampling rate in Hz [default: 16000]"/>
      <Parameter name="FBANK_COUNT" type="subnet_param" value="int:ARG5" description="Number of filter banks of FBANK. [default: 24]"/>
      <Parameter name="WN_LEVEL" type="subnet_param" value="float:ARG7" description="An amplitude of white noise."/>
      <Parameter name="NUM_CEPS" type="subnet_param" value="int:ARG6" description="Number of Cepstrum coefficients. [default: 12]"/>
      <Parameter name="WLENGTH" type="int" value="400" description="The length of the window."/>
      <Parameter name="DOWHILE" type="bool" value="" description=""/>
    </Node>
    <Node name="node_Constant_1" type="Constant" x="-265.000000" y="28.000000">
      <Parameter name="VALUE" type="subnet_param" value="ARG1" description="The value"/>
    </Node>
    <Node name="node_InputStream_1" type="InputStream" x="-156.000000" y="28.000000">
      <Parameter name="TYPE" type="String" value="" description="Type of stream: stream, fd, or FILE (default stream)"/>
      <Parameter name="RETRY" type="int" value="" description="If set to N, InputStream will retry N times on open fail"/>
    </Node>
    <Link from="node_Constant_1" output="VALUE" to="node_InputStream_1" input="INPUT"/>
    <Link from="node_InputStream_1" output="OUTPUT" to="node_LOOP0_1" input="IN"/>
    <NetOutput name="ASR" node="node_LOOP0_1" terminal="ASR" object_type="Vector&lt;ObjectRef&gt;" description="The same as SOURCES."/>
    <Note x="0" y="0" visible="0" text="Created with FlowDesigner 0.9.1"/>
  </Network>
  <Network type="iterator" name="LOOP0">
    <Node name="node_AudioStreamFromWave_1" type="AudioStreamFromWave" x="-209.000000" y="-25.000000">
      <Parameter name="LENGTH" type="subnet_param" value="LENGTH" description="The length of a frame in one channel (in samples)."/>
      <Parameter name="ADVANCE" type="subnet_param" value="ADVANCE" description="The shift length beween adjacent frames (in samples)."/>
      <Parameter name="USE_WAIT" type="bool" value="false" description="If true, wait as really recording."/>
    </Node>
    <Node name="node_MultiFFT_1" type="MultiFFT" x="149.000000" y="-32.000000">
      <Parameter name="LENGTH" type="subnet_param" value="LENGTH" description="The length of FFT."/>
      <Parameter name="WINDOW" type="string" value="CONJ" description="A window function for FFT. WINDOW should be CONJ, HAMMING, or RECTANGLE."/>
      <Parameter name="WINDOW_LENGTH" type="subnet_param" value="LENGTH" description="The length of the window."/>
    </Node>
    <Node name="node_ChannelSelector_1" type="ChannelSelector" x="34.000000" y="-32.000000">
      <Parameter name="SELECTOR" type="object" value="&lt;Vector&lt;int&gt; 0 &gt;" description="Flags for channel selection. When the first three channels are selected from four channels, the flags should be set to &lt;Vector&lt;int&gt; 0 1 2&gt;."/>
    </Node>
    <Node name="node_MatrixToMap_1" type="MatrixToMap" x="257.000000" y="-32.000000"/>
    <Node name="node_MelFilterBank_1" type="MelFilterBank" x="222.000000" y="40.000000">
      <Parameter name="LENGTH" type="subnet_param" value="LENGTH" description="Size of window length."/>
      <Parameter name="SAMPLING_RATE" type="subnet_param" value="SAMPLING_RATE" description="Sampling rate (Hz)."/>
      <Parameter name="CUTOFF" type="int" value="8000" description="Cutoff frequency. A frequency band between 0Hz to the cutoff frequency is used for calculation."/>
      <Parameter name="MIN_FREQUENCY" type="int" value="63" description="Minimum frequency (Hz) [default: 63]"/>
      <Parameter name="MAX_FREQUENCY" type="int" value="8000" description="Maximum frequency (Hz) [default: 8000]"/>
      <Parameter name="FBANK_COUNT" type="subnet_param" value="FBANK_COUNT" description="The number of filter banks."/>
    </Node>
    <Node name="node_Delta_1" type="Delta" x="234.000000" y="128.000000">
      <Parameter name="FBANK_COUNT" type="int" value="13" description="The number of static components of the input feature vector."/>
    </Node>
    <Node name="node_WhiteNoiseAdder_1" type="WhiteNoiseAdder" x="-222.000000" y="40.000000">
      <Parameter name="LENGTH" type="subnet_param" value="LENGTH" description="The size of window length."/>
      <Parameter name="WN_LEVEL" type="subnet_param" value="WN_LEVEL" description="An amplitude of white noise."/>
    </Node>
    <Node name="node_MFCCExtraction_1" type="MFCCExtraction" x="-153.000000" y="120.000000">
      <Parameter name="FBANK_COUNT" type="subnet_param" value="FBANK_COUNT" description="Number of filter banks of FBANK. [default: 24]"/>
      <Parameter name="NUM_CEPS" type="subnet_param" value="NUM_CEPS" description="Number of Cepstrum coefficients. [default: 12]"/>
      <Parameter name="USE_POWER" type="bool" value="true" description="Use power feature if true."/>
    </Node>
    <Node name="node_ConstantLocalization_1" type="ConstantLocalization" x="-199.000000" y="228.000000">
      <Parameter name="ANGLES" type="object" value="&lt;Vector&lt;float&gt; 0 &gt;" description="A vector to specify source locations. Each vector element shows azimuth of a source in degree."/>
      <Parameter name="ELEVATIONS" type="object" value="&lt;Vector&lt;float&gt; 0 &gt;" description="Elevations of source locations. Each element represents an elevation of each source location."/>
    </Node>
    <Node name="node_SpeechRecognitionClient_1" type="SpeechRecognitionClient" x="132.000000" y="213.000000">
      <Parameter name="MFT_ENABLED" type="bool" value="false" description="MFT is enbaled if true. [default: true]"/>
      <Parameter name="HOST" type="string" value="127.0.0.1" description="Hostname or IP of Julius/Julian server. [default: 127.0.0.1]"/>
      <Parameter name="PORT" type="int" value="5530" description="Port number of Julius/Julian server. [default: 5530]"/>
      <Parameter name="SOCKET_ENABLED" type="bool" value="true" description="send data via socket if true. [default: true]"/>
    </Node>
    <Node name="node_Synthesize_1" type="Synthesize" x="-98.000000" y="40.000000">
      <Parameter name="LENGTH" type="subnet_param" value="LENGTH" description="Size of window length in sample. [default: 512]"/>
      <Parameter name="ADVANCE" type="subnet_param" value="ADVANCE" description="The length in sample between a frame and a previous frame. [default: 160]"/>
      <Parameter name="SAMPLING_RATE" type="subnet_param" value="SAMPLING_RATE" description="Sampling rate (Hz) [default: 16000]."/>
      <Parameter name="MIN_FREQUENCY" type="int" value="125" description="Minimum frequency (Hz) [default: 125]"/>
      <Parameter name="MAX_FREQUENCY" type="int" value="7900" description="Maximum frequency (Hz) [default: 7900]"/>
      <Parameter name="WINDOW" type="string" value="HAMMING" description="A window function for overlap-add. WINDOW should be CONJ, HAMMING, or RECTANGLE. [default: HAMMING]"/>
      <Parameter name="OUTPUT_GAIN" type="float" value="1.0" description="Output gain factor. [default: 1.0]"/>
    </Node>
    <Node name="node_PreEmphasis_1" type="PreEmphasis" x="17.000000" y="40.000000">
      <Parameter name="LENGTH" type="subnet_param" value="LENGTH" description="window length in sample [default: 512]"/>
      <Parameter name="SAMPLING_RATE" type="subnet_param" value="SAMPLING_RATE" description="Sampling rate in Hz [default: 16000]"/>
      <Parameter name="PREEMCOEF" type="float" value="0.97" description="pre-emphasis coefficient [default: 0.97]"/>
      <Parameter name="INPUT_TYPE" type="string" value="WAV" description="The domain to perform pre-emphasis [default: WAV]"/>
    </Node>
    <Node name="node_MultiFFT_2" type="MultiFFT" x="118.000000" y="40.000000">
      <Parameter name="LENGTH" type="subnet_param" value="LENGTH" description="The length of FFT."/>
      <Parameter name="WINDOW" type="string" value="HAMMING" description="A window function for FFT. WINDOW should be CONJ, HAMMING, or RECTANGLE."/>
      <Parameter name="WINDOW_LENGTH" type="subnet_param" value="WLENGTH" description="The length of the window."/>
    </Node>
    <Node name="node_FeatureRemover_1" type="FeatureRemover" x="337.000000" y="128.000000">
      <Parameter name="SELECTOR" type="object" value="&lt;Vector&lt;int&gt; 12 &gt;" description="Component indices in a feature vector to remove. E.g. &lt;Vector&lt;int&gt; 13&gt; to remove 14th comopnent (The index start with 0)."/>
    </Node>
    <Node name="node_SpectralMeanNormalization_1" type="SpectralMeanNormalization" x="92.000000" y="128.000000">
      <Parameter name="FBANK_COUNT" type="int" value="13" description="Size of a static part of a feature vector. [default: 13]"/>
    </Node>
    <Link from="node_AudioStreamFromWave_1" output="AUDIO" to="node_ChannelSelector_1" input="INPUT"/>
    <Link from="node_ChannelSelector_1" output="OUTPUT" to="node_MultiFFT_1" input="INPUT"/>
    <Link from="node_MatrixToMap_1" output="OUTPUT" to="node_WhiteNoiseAdder_1" input="INPUT">303 -32 320 -32 320 11 -301 11 -301 40 -280.5 40 </Link>
    <Link from="node_MelFilterBank_1" output="OUTPUT" to="node_MFCCExtraction_1" input="FBANK">270 40 318 40 318 75 -301 75 -301 112 -283 112.5 </Link>
    <Link from="node_ConstantLocalization_1" output="SOURCES" to="node_SpeechRecognitionClient_1" input="SOURCES"/>
    <Link from="node_MultiFFT_1" output="OUTPUT" to="node_MatrixToMap_1" input="INPUT"/>
    <Link from="node_WhiteNoiseAdder_1" output="OUTPUT" to="node_Synthesize_1" input="INPUT"/>
    <Link from="node_Synthesize_1" output="OUTPUT" to="node_PreEmphasis_1" input="INPUT"/>
    <Link from="node_PreEmphasis_1" output="OUTPUT" to="node_MultiFFT_2" input="INPUT"/>
    <Link from="node_MultiFFT_2" output="OUTPUT" to="node_MelFilterBank_1" input="INPUT"/>
    <Link from="node_MultiFFT_2" output="OUTPUT" to="node_MFCCExtraction_1" input="SPECTRUM">150.5 40 160 40 160 90 -333 90 -333 128 -283 127.5 </Link>
    <Link from="node_Delta_1" output="OUTPUT" to="node_FeatureRemover_1" input="INPUT"/>
    <Link from="node_FeatureRemover_1" output="OUTPUT" to="node_SpeechRecognitionClient_1" input="FEATURES">391 128 413 128 413 169 -65 169 -65 198 -21 198 </Link>
    <Link from="node_FeatureRemover_1" output="OUTPUT" to="node_SpeechRecognitionClient_1" input="MASKS">391 128 413 128 413 169 -66 169 -66 213 -21 213 </Link>
    <Link from="node_MFCCExtraction_1" output="OUTPUT" to="node_SpectralMeanNormalization_1" input="FBANK"/>
    <Link from="node_SpectralMeanNormalization_1" output="OUTPUT" to="node_Delta_1" input="INPUT"/>
    <Link from="node_ConstantLocalization_1" output="SOURCES" to="node_SpectralMeanNormalization_1" input="SOURCES">-128.5 228 -90 228 -90 135 -66 135.5 </Link>
    <NetCondition name="CONDITION" node="node_AudioStreamFromWave_1" terminal="NOT_EOF"/>
    <NetOutput name="ASR" node="node_SpeechRecognitionClient_1" terminal="OUTPUT" object_type="Vector&lt;ObjectRef&gt;" description="The same as SOURCES."/>
    <NetInput name="IN" node="node_AudioStreamFromWave_1" terminal="INPUT" object_type="Stream" description="An audio input stream (IStream)."/>
    <Note x="0" y="0" visible="0" text="Created with FlowDesigner 0.9.1"/>
  </Network>
  <Parameter name="int:ARG2" type="" value=""/>
  <Parameter name="int:ARG3" type="" value=""/>
  <Parameter name="int:ARG4" type="" value=""/>
  <Parameter name="int:ARG5" type="" value=""/>
  <Parameter name="float:ARG7" type="" value=""/>
  <Parameter name="int:ARG6" type="" value=""/>
  <Parameter name="ARG1" type="" value=""/>
</Document>
