#!/usr/bin/env batchflow
<?xml version="1.0"?>
<Document>
  <Network type="subnet" name="MAIN">
    <Node name="node_LOOP0_1" type="LOOP0" x="-60.000000" y="28.000000">
      <Parameter name="LENGTH" type="subnet_param" value="int:ARG4" description="The length of a frame in one channel (in samples)."/>
      <Parameter name="ADVANCE" type="subnet_param" value="int:ARG5" description="The shift length beween adjacent frames (in samples)."/>
      <Parameter name="SAMPLING_RATE" type="subnet_param" value="int:ARG6" description="Sampling rate (Hz) [default: 16000]."/>
      <Parameter name="TF_CONJ_FILENAME" type="subnet_param" value="ARG3" description="Filename of a pre-measured transfer function for separation."/>
      <Parameter name="A_MATRIX" type="subnet_param" value="ARG2" description="Filename of a transfer function matrix."/>
      <Parameter name="TH" type="subnet_param" value="float:ARG7" description="Power threshold for localization results. A localization result with higher power than THRESH is tracked, otherwise ignored."/>
      <Parameter name="WLENGTH" type="int" value="400" description="The length of the window."/>
      <Parameter name="DOWHILE" type="bool" value="" description=""/>
    </Node>
    <Node name="node_Constant_1" type="Constant" x="-259.000000" y="28.000000">
      <Parameter name="VALUE" type="subnet_param" value="ARG1" description="The value"/>
    </Node>
    <Node name="node_InputStream_1" type="InputStream" x="-156.000000" y="28.000000">
      <Parameter name="TYPE" type="String" value="" description="Type of stream: stream, fd, or FILE (default stream)"/>
      <Parameter name="RETRY" type="int" value="" description="If set to N, InputStream will retry N times on open fail"/>
    </Node>
    <Link from="node_Constant_1" output="VALUE" to="node_InputStream_1" input="INPUT"/>
    <Link from="node_InputStream_1" output="OUTPUT" to="node_LOOP0_1" input="IN"/>
    <NetOutput name="ASR" node="node_LOOP0_1" terminal="ASR" object_type="Vector&lt;ObjectRef&gt;" description="The same as SOURCES."/>
    <NetOutput name="OUTPUT" node="node_LOOP0_1" terminal="OUTPUT" object_type="any" description="No description available"/>
    <Note x="0" y="0" visible="0" text="Created with FlowDesigner 0.9.1"/>
  </Network>
  <Network type="iterator" name="LOOP0">
    <Node name="node_AudioStreamFromWave_1" type="AudioStreamFromWave" x="-233.000000" y="-25.000000">
      <Parameter name="LENGTH" type="subnet_param" value="LENGTH" description="The length of a frame in one channel (in samples)."/>
      <Parameter name="ADVANCE" type="subnet_param" value="ADVANCE" description="The shift length beween adjacent frames (in samples)."/>
      <Parameter name="USE_WAIT" type="bool" value="false" description="If true, wait as really recording."/>
    </Node>
    <Node name="node_MultiFFT_1" type="MultiFFT" x="49.000000" y="-32.000000">
      <Parameter name="LENGTH" type="subnet_param" value="LENGTH" description="The length of FFT."/>
      <Parameter name="WINDOW" type="string" value="CONJ" description="A window function for FFT. WINDOW should be CONJ, HAMMING, or RECTANGLE."/>
      <Parameter name="WINDOW_LENGTH" type="subnet_param" value="LENGTH" description="The length of the window."/>
    </Node>
    <Node name="node_MelFilterBank_1" type="MelFilterBank" x="-97.000000" y="125.000000">
      <Parameter name="LENGTH" type="subnet_param" value="LENGTH" description="Size of window length."/>
      <Parameter name="SAMPLING_RATE" type="subnet_param" value="SAMPLING_RATE" description="Sampling rate (Hz)."/>
      <Parameter name="CUTOFF" type="int" value="8000" description="Cutoff frequency. A frequency band between 0Hz to the cutoff frequency is used for calculation."/>
      <Parameter name="MIN_FREQUENCY" type="int" value="63" description="Minimum frequency (Hz) [default: 63]"/>
      <Parameter name="MAX_FREQUENCY" type="int" value="8000" description="Maximum frequency (Hz) [default: 8000]"/>
      <Parameter name="FBANK_COUNT" type="int" value="13" description="The number of filter banks."/>
    </Node>
    <Node name="node_Delta_1" type="Delta" x="3.000000" y="213.000000">
      <Parameter name="FBANK_COUNT" type="int" value="14" description="The number of static components of the input feature vector."/>
    </Node>
    <Node name="node_WhiteNoiseAdder_1" type="WhiteNoiseAdder" x="-243.000000" y="125.000000">
      <Parameter name="LENGTH" type="subnet_param" value="LENGTH" description="The size of window length."/>
      <Parameter name="WN_LEVEL" type="float" value="100" description="An amplitude of white noise."/>
    </Node>
    <Node name="node_SpeechRecognitionClient_1" type="SpeechRecognitionClient" x="180.000000" y="396.000000">
      <Parameter name="MFT_ENABLED" type="bool" value="false" description="MFT is enbaled if true. [default: true]"/>
      <Parameter name="HOST" type="string" value="127.0.0.1" description="Hostname or IP of Julius/Julian server. [default: 127.0.0.1]"/>
      <Parameter name="PORT" type="int" value="5530" description="Port number of Julius/Julian server. [default: 5530]"/>
      <Parameter name="SOCKET_ENABLED" type="bool" value="true" description="send data via socket if true. [default: true]"/>
    </Node>
    <Node name="node_SpectralMeanNormalization_1" type="SpectralMeanNormalization" x="-139.000000" y="213.000000">
      <Parameter name="FBANK_COUNT" type="int" value="14" description="Size of a static part of a feature vector. [default: 13]"/>
    </Node>
    <Node name="node_GHDSS_1" type="GHDSS" x="282.000000" y="-24.000000">
      <Parameter name="LENGTH" type="subnet_param" value="LENGTH" description="The frame length of each channel (in samples) [default: 512]."/>
      <Parameter name="ADVANCE" type="subnet_param" value="ADVANCE" description="The shift length beween adjacent frames (in samples)[default: 160]."/>
      <Parameter name="SAMPLING_RATE" type="subnet_param" value="SAMPLING_RATE" description="Sampling rate (Hz) [default: 16000]."/>
      <Parameter name="LOWER_BOUND_FREQUENCY" type="int" value="0" description="Lower bound of frequency (Hz). [default: 0]"/>
      <Parameter name="UPPER_BOUND_FREQUENCY" type="int" value="8000" description="Upper bound of frequency (Hz). [default: 8000]"/>
      <Parameter name="TF_CONJ" type="string" value="DATABASE" description="Transfer function (TF) type. CALC generates TF from the geometrical relationship between microphones and a sound source, and DATABASE uses pre-measured TF [default: CALC]."/>
      <Parameter name="TF_CONJ_FILENAME" type="subnet_param" value="TF_CONJ_FILENAME" description="Filename of a pre-measured transfer function for separation."/>
      <Parameter name="MIC_FILENAME" type="string" value="" description="Filename for microphone positions."/>
      <Parameter name="MIC_POS_SHIFT" type="string" value="FIX" description="Method to decide the orgin of the coordinates. FIX uses the origin in the coordinates in MIC_FILENAME, SHIFT regards the center of microphone array as the origin. [default: FIX]"/>
      <Parameter name="FIXED_NOISE" type="bool" value="false" description="Flag to specify fixed noise sources. [default: false]"/>
      <Parameter name="FIXED_NOISE_FILENAME" type="string" value="" description="Filename describing sound locations of the fixed noise sources. The specified noise sources are always separated in addition to sound sources in INPUT_SOURCES. Available only when FIXED_NOISE = true."/>
      <Parameter name="INITW_FILENAME" type="string" value="" description="Filename of an initial separation matrix. If specified, a matrix in INITW_FILENAME is used as an initial separation matrix. Otherwise, initial separation matrix is estimated from the geometrical relationship or pre-measured TF according to TF_CONJ."/>
      <Parameter name="SPEED_OF_SOUND" type="float" value="343.0" description="Speed of sound(m/s) [default: 343.0]."/>
      <Parameter name="SS_METHOD" type="string" value="ADAPTIVE" description="The calculation method for SS step size parameter corresponding to the blind separation part. &quot;FIX&quot; uses a fixed step size,&quot;LC_MYU&quot; uses the same value as LC_MYU, and &quot;ADAPTIVE&quot; adaptively estimates an optimal step size. [default: FIX]"/>
      <Parameter name="SS_SCAL" type="float" value="1.0" description="Scaling factor for SS step size. [default: 1.0]"/>
      <Parameter name="SS_MYU" type="float" value="0.001" description="SS step size value. [default 0.001]"/>
      <Parameter name="NOISE_FLOOR" type="float" value="0.0" description="Noise floor value. [default 0.0]"/>
      <Parameter name="LC_CONST" type="string" value="DIAG" description="The calculation method for geometric constraints. &quot;FULL&quot; uses all elements of a matrix, and &quot;DIAG&quot; only uses diagonal parts. [default: FULL]"/>
      <Parameter name="LC_METHOD" type="string" value="ADAPTIVE" description="The calculation method for LC step size corresponding to geometric constraints. &quot;FIX&quot; uses a fixed value, and &quot;Adaptive&quot; adaptively estimates an optimal step size. [default: FIX]"/>
      <Parameter name="LC_MYU" type="float" value="0.001" description="LC step size value. [default 0.001]"/>
      <Parameter name="UPDATE_METHOD_TF_CONJ" type="string" value="POS" description="Switching method of TF_CONJ data. [default: POS]"/>
      <Parameter name="UPDATE_METHOD_W" type="string" value="ID" description="Switching method of separation matrix, W. [default: ID]"/>
      <Parameter name="UPDATE_ACCEPT_ANGLE" type="float" value="5.0" description="Angle allowance to switch separation matrix in degree. available when when UPDATE_METHOD_W is POS or ID_POS. [default: 5.0]"/>
      <Parameter name="EXPORT_W" type="bool" value="false" description="Separation matrix W is exported if true. [default: false]"/>
      <Parameter name="EXPORT_W_FILENAME" type="string" value="" description="The filename to export W."/>
      <Parameter name="UPDATE" type="string" value="STEP" description="The update method of separation matrix. &quot;STEP&quot; updates W sequentially, i.e., based on SS and then on LC cost. &quot;TOTAL&quot; updates W based on an integrated value of SS and LC cost [default: STEP]"/>
    </Node>
    <Node name="node_LocalizeMUSIC_1" type="LocalizeMUSIC" x="-163.000000" y="-102.000000">
      <Parameter name="NB_CHANNELS" type="int" value="8" description="The number of input channels. [default: 8]"/>
      <Parameter name="LENGTH" type="subnet_param" value="LENGTH" description="The frame length of each channel (in samples) [default: 512]."/>
      <Parameter name="SAMPLING_RATE" type="subnet_param" value="SAMPLING_RATE" description="Sampling rate (Hz) [default: 16000]."/>
      <Parameter name="A_MATRIX" type="subnet_param" value="A_MATRIX" description="Filename of a transfer function matrix."/>
      <Parameter name="ELEVATION" type="float" value="15.0" description="An angle of elevation for source locations in degree. [default: 15.0]"/>
      <Parameter name="PERIOD" type="int" value="50" description="The number of frames used for calculating a correlation matrix. [default: 50]"/>
      <Parameter name="NUM_SOURCE" type="int" value="2" description="Number of sources, which should be less than NB_CHANNELS [default: 2]."/>
      <Parameter name="MIN_DEG" type="int" value="-180" description="Minimum source direction to localize in degree. [default: -180]"/>
      <Parameter name="MAX_DEG" type="int" value="180" description="Maximum source direction to localize in degree. [default: 180]"/>
      <Parameter name="LOWER_BOUND_FREQUENCY" type="int" value="500" description="Lower bound of frequency (Hz) used for correlation matrix calculation. [default: 500]"/>
      <Parameter name="UPPER_BOUND_FREQUENCY" type="int" value="2800" description="Upper bound of frequency (Hz) used for correlation function matrix. [default: 2800]"/>
      <Parameter name="DEBUG" type="bool" value="false" description="Debug option. If true, output sound localization results to standard output. [default: false]"/>
    </Node>
    <Node name="node_SourceTracker_1" type="SourceTracker" x="-16.000000" y="-102.000000">
      <Parameter name="THRESH" type="subnet_param" value="TH" description="Power threshold for localization results. A localization result with higher power than THRESH is tracked, otherwise ignored."/>
      <Parameter name="PAUSE_LENGTH" type="float" value="800" description="Life duration of source in ms. When any localization result for a source is found for more than PAUSE_LENGTH / 10 iterations, the source is terminated. [default: 800]"/>
      <Parameter name="MIN_SRC_INTERVAL" type="float" value="20" description="Source interval threshold in degree. When the angle between a localization result and a source is smaller than MIN_SRC_INTERVAL, the same ID is given to the localization result. [default: 20]"/>
      <Parameter name="MIN_ID" type="int" value="0" description="Minimum ID of source locations. MIN_ID should be greater than 0 or equal."/>
      <Parameter name="DEBUG" type="bool" value="false" description="Output debug information if true [default: false]"/>
    </Node>
    <Node name="node_SourceIntervalExtender_1" type="SourceIntervalExtender" x="152.000000" y="-102.000000">
      <Parameter name="PREROLL_LENGTH" type="int" value="0" description="Preroll length in frame. [default: 50]"/>
    </Node>
    <Node name="node_PostFilter_1" type="PostFilter" x="147.000000" y="57.000000">
      <Parameter name="MCRA_SETTING" type="bool" value="false" description="Set the MCRA parameters [default:false]"/>
      <Parameter name="EST_LEAK_SETTING" type="bool" value="false" description="Set the EST_LEAK parameters[default:false]"/>
      <Parameter name="EST_REV_SETTING" type="bool" value="false" description="Set the EST_REV parameters[default:false]"/>
      <Parameter name="EST_SN_SETTING" type="bool" value="false" description="Set the EST_SN parameters[default:false]"/>
      <Parameter name="EST_VOICEP_SETTING" type="bool" value="false" description="Set the EST_REV parameters[default:false]"/>
      <Parameter name="STATIONARY_NOISE_FACTOR" type="float" value="1.2" description="Stationary noise estimation factor[default:1.2]"/>
      <Parameter name="SPEC_SMOOTH_FACTOR" type="float" value="0.5" description="Smoothing factor for input power spectrum [default:0.5]"/>
      <Parameter name="AMP_LEAK_FACTOR" type="float" value="1.5" description="Leak factor [default:1.5]"/>
      <Parameter name="STATIONARY_NOISE_MIXTURE_FACTOR" type="float" value="0.98" description="The mixture rate of stationary noise [default:0.98]"/>
      <Parameter name="LEAK_FACTOR" type="float" value="0.25" description="Leak rate [default:0.25]"/>
      <Parameter name="OVER_CANCEL_FACTOR" type="float" value="1" description="The weighting factor for leak rate [default:1]"/>
      <Parameter name="REVERB_DECAY_FACTOR" type="float" value="0.5" description="The decay factor for reverblate power [default:0.5]"/>
      <Parameter name="DIRECT_DECAY_FACTOR" type="float" value="0.2" description="The decay factor for separated spectrum [default:0.2]"/>
      <Parameter name="PRIOR_SNR_FACTOR" type="float" value="0.8" description="The rate of prior and posterior SNR [default:0.8]"/>
      <Parameter name="PRIOR_SNR_SMOOTH_FACTOR" type="float" value="0.7" description="Smoothing factor [default:0.7]"/>
      <Parameter name="LEAK_FLOOR" type="float" value="0.1" description="The min value of leak noise [default:0.1]"/>
      <Parameter name="BLOCK_LENGTH" type="int" value="80" description="Time interval for detection [default:80]"/>
      <Parameter name="VOICEP_THRESHOLD" type="float" value="3" description="Threshold level for check the voice probability [default:3]"/>
      <Parameter name="VOICEP_PROB_FACTOR" type="float" value="0.9" description="Amplitude factor for voice probability [default:0.9]"/>
      <Parameter name="MIN_VOICEP_PROB" type="float" value="0.05" description="Min value of voice probability [default:0.05]"/>
      <Parameter name="MAX_PRIOR_SNR" type="float" value="100" description="Max value of prior SNR [default:100]"/>
      <Parameter name="MAX_OPT_GAIN" type="float" value="20" description="Max value of optimum gain mid variable(v) [default:20]"/>
      <Parameter name="MIN_OPT_GAIN" type="float" value="6" description="Min value of optimum gain mid variable(v) [default:6]"/>
      <Parameter name="MIN_FRAME_SMOOTH_SNR" type="float" value="0.1" description="Min value of frequency smoothing SNR(frame) [default:0.1]"/>
      <Parameter name="MAX_FRAME_SMOOTH_SNR" type="float" value="0.316" description="Max value of frequency smoothing SNR(frame) [default:0.316]"/>
      <Parameter name="MIN_GLOBAL_SMOOTH_SNR" type="float" value="0.1" description="Min value of frequency smoothing SNR(global) [default:0.1]"/>
      <Parameter name="MAX_GLOBAL_SMOOTH_SNR" type="float" value="0.316" description="Max value of frequency smoothing SNR(global) [default:0.316]"/>
      <Parameter name="MIN_LOCAL_SMOOTH_SNR" type="float" value="0.1" description="Min value of frequency smoothing SNR(local) [default:0.1]"/>
      <Parameter name="MAX_LOCAL_SMOOTH_SNR" type="float" value="0.316" description="Max value of frequency smoothing SNR(local) [default:0.316]"/>
      <Parameter name="UPPER_SMOOTH_FREQ_INDEX" type="int" value="99" description="Upper bound frequency index used smoothing [default:99]"/>
      <Parameter name="LOWER_SMOOTH_FREQ_INDEX" type="int" value="8" description="Lower bound frequency index used smoothing [default:8]"/>
      <Parameter name="GLOBAL_SMOOTH_BANDWIDTH" type="int" value="29" description="Frequency smoothing bandwidth(global) [default:29]"/>
      <Parameter name="LOCAL_SMOOTH_BANDWIDTH" type="int" value="5" description="Frequency smoothing bandwidth(local) [default:5]"/>
      <Parameter name="FRAME_SMOOTH_SNR_THRESH" type="float" value="1.5" description="Threshold of frequency smoothing SNR(frame) [default:1.5]"/>
      <Parameter name="MIN_SMOOTH_PEAK_SNR" type="float" value="1" description="Min peak value of frequency smoothing SNR [default:1]"/>
      <Parameter name="MAX_SMOOTH_PEAK_SNR" type="float" value="10" description="Max peak value of frequency smoothing SNR [default:10]"/>
      <Parameter name="FRAME_VOICEP_PROB_FACTOR" type="float" value="0.7" description="The voice probability smoothing factor(frame) [default:0.7]"/>
      <Parameter name="GLOBAL_VOICEP_PROB_FACTOR" type="float" value="0.9" description="The voice probability smoothing factor(global) [default:0.9]"/>
      <Parameter name="LOCAL_VOICEP_PROB_FACTOR" type="float" value="0.9" description="The voice probability smoothing factor(local) [default:0.9]"/>
      <Parameter name="MIN_VOICE_PAUSE_PROB" type="float" value="0.02" description="Min value of voice pause probability [default:0.02]"/>
      <Parameter name="MAX_VOICE_PAUSE_PROB" type="float" value="0.98" description="Max value of voice pause probability [default:0.98]"/>
    </Node>
    <Node name="node_BGNEstimator_1" type="BGNEstimator" x="-94.000000" y="65.000000">
      <Parameter name="DELTA" type="float" value="3.0" description="Power ratio used to decide a threshold to distinguish target signal and background noise. When this value is large, frequency bins with higher power are regarded as background noise, vice versa [default:3.0]"/>
      <Parameter name="L" type="int" value="150" description="Time window length (in frame) to decide the lowest noise power spectrum, Smin [default:150]"/>
      <Parameter name="ALPHA_S" type="float" value="0.7" description="A coefficient for temporal smoothing of input spectrum [default:0.7]"/>
      <Parameter name="NOISE_COMPENS" type="float" value="1.0" description="Weight factor for background noise frames on smoothing [default: 1.0]"/>
      <Parameter name="ALPHA_D_MIN" type="float" value="0.05" description="Minimum weight factor for signal (speech) frames [default:0.05]"/>
      <Parameter name="NUM_INIT_FRAME" type="int" value="100" description="Duration in frame to initialize background noise power spectrum. All frames within this duration at the begining of processing are regarded as noise. [default:100]"/>
    </Node>
    <Node name="node_PowerCalcForMatrix_1" type="PowerCalcForMatrix" x="-235.000000" y="65.000000"/>
    <Node name="node_MSLSExtraction_1" type="MSLSExtraction" x="131.000000" y="133.000000">
      <Parameter name="FBANK_COUNT" type="int" value="13" description="Size of the static part of MFCC feature vector. [default: 13]"/>
      <Parameter name="NORMALIZATION_MODE" type="string" value="SPECTRAL" description="The domain to perform normalization. CEPSTRAL or SPECTRAL. [default: CEPSTRAL]"/>
      <Parameter name="USE_POWER" type="bool" value="true" description="Use power feature if true. [default: false]"/>
    </Node>
    <Node name="node_FeatureRemover_1" type="FeatureRemover" x="113.000000" y="213.000000">
      <Parameter name="SELECTOR" type="object" value="&lt;Vector&lt;int&gt; 13 &gt;" description="Component indices in a feature vector to remove. E.g. &lt;Vector&lt;int&gt; 13&gt; to remove 14th comopnent (The index start with 0)."/>
    </Node>
    <Node name="node_MFMGeneration_1" type="MFMGeneration" x="-32.000000" y="303.000000">
      <Parameter name="FBANK_COUNT" type="int" value="13" description="Size of the static part of a feature vector. [default: 13]"/>
      <Parameter name="THRESHOLD" type="float" value="0.5" description="Threshold for missing feature mask generation. The threshold should be between 0 and 1. [default: 0.2]"/>
    </Node>
    <Node name="node_MelFilterBank_2" type="MelFilterBank" x="-253.000000" y="328.000000">
      <Parameter name="LENGTH" type="subnet_param" value="LENGTH" description="Size of window length."/>
      <Parameter name="SAMPLING_RATE" type="subnet_param" value="SAMPLING_RATE" description="Sampling rate (Hz)."/>
      <Parameter name="CUTOFF" type="int" value="8000" description="Cutoff frequency. A frequency band between 0Hz to the cutoff frequency is used for calculation."/>
      <Parameter name="MIN_FREQUENCY" type="int" value="63" description="Minimum frequency (Hz) [default: 63]"/>
      <Parameter name="MAX_FREQUENCY" type="int" value="8000" description="Maximum frequency (Hz) [default: 8000]"/>
      <Parameter name="FBANK_COUNT" type="int" value="13" description="The number of filter banks."/>
    </Node>
    <Node name="node_MelFilterBank_3" type="MelFilterBank" x="-254.000000" y="288.000000">
      <Parameter name="LENGTH" type="subnet_param" value="LENGTH" description="Size of window length."/>
      <Parameter name="SAMPLING_RATE" type="subnet_param" value="SAMPLING_RATE" description="Sampling rate (Hz)."/>
      <Parameter name="CUTOFF" type="int" value="8000" description="Cutoff frequency. A frequency band between 0Hz to the cutoff frequency is used for calculation."/>
      <Parameter name="MIN_FREQUENCY" type="int" value="63" description="Minimum frequency (Hz) [default: 63]"/>
      <Parameter name="MAX_FREQUENCY" type="int" value="8000" description="Maximum frequency (Hz) [default: 8000]"/>
      <Parameter name="FBANK_COUNT" type="int" value="13" description="The number of filter banks."/>
    </Node>
    <Node name="node_MelFilterBank_4" type="MelFilterBank" x="-254.000000" y="370.000000">
      <Parameter name="LENGTH" type="subnet_param" value="LENGTH" description="Size of window length."/>
      <Parameter name="SAMPLING_RATE" type="subnet_param" value="SAMPLING_RATE" description="Sampling rate (Hz)."/>
      <Parameter name="CUTOFF" type="int" value="8000" description="Cutoff frequency. A frequency band between 0Hz to the cutoff frequency is used for calculation."/>
      <Parameter name="MIN_FREQUENCY" type="int" value="63" description="Minimum frequency (Hz) [default: 63]"/>
      <Parameter name="MAX_FREQUENCY" type="int" value="8000" description="Maximum frequency (Hz) [default: 8000]"/>
      <Parameter name="FBANK_COUNT" type="int" value="13" description="The number of filter banks."/>
    </Node>
    <Node name="node_DeltaMask_1" type="DeltaMask" x="82.000000" y="303.000000">
      <Parameter name="FBANK_COUNT" type="int" value="13" description="The size of the input mask vector."/>
    </Node>
    <Node name="node_DeltaPowerMask_1" type="DeltaPowerMask" x="197.000000" y="303.000000"/>
    <Node name="node_Synthesize_1" type="Synthesize" x="401.000000" y="50.000000">
      <Parameter name="LENGTH" type="subnet_param" value="LENGTH" description="Size of window length in sample. [default: 512]"/>
      <Parameter name="ADVANCE" type="subnet_param" value="ADVANCE" description="The length in sample between a frame and a previous frame. [default: 160]"/>
      <Parameter name="SAMPLING_RATE" type="subnet_param" value="SAMPLING_RATE" description="Sampling rate (Hz) [default: 16000]."/>
      <Parameter name="MIN_FREQUENCY" type="int" value="125" description="Minimum frequency (Hz) [default: 125]"/>
      <Parameter name="MAX_FREQUENCY" type="int" value="7900" description="Maximum frequency (Hz) [default: 7900]"/>
      <Parameter name="WINDOW" type="string" value="HAMMING" description="A window function for overlap-add. WINDOW should be CONJ, HAMMING, RECTANGLE, or HANNING. [default: HAMMING]"/>
      <Parameter name="OUTPUT_GAIN" type="float" value="1.0" description="Output gain factor. [default: 1.0]"/>
    </Node>
    <Node name="node_PreEmphasis_1" type="PreEmphasis" x="-450.000000" y="125.000000">
      <Parameter name="LENGTH" type="subnet_param" value="LENGTH" description="window length in sample [default: 512]"/>
      <Parameter name="SAMPLING_RATE" type="subnet_param" value="SAMPLING_RATE" description="Sampling rate in Hz [default: 16000]"/>
      <Parameter name="PREEMCOEF" type="float" value="0.97" description="pre-emphasis coefficient [default: 0.97]"/>
      <Parameter name="INPUT_TYPE" type="string" value="WAV" description="The domain to perform pre-emphasis [default: WAV]"/>
    </Node>
    <Node name="node_MultiFFT_2" type="MultiFFT" x="-353.000000" y="125.000000">
      <Parameter name="LENGTH" type="subnet_param" value="LENGTH" description="The length of FFT."/>
      <Parameter name="WINDOW" type="string" value="CONJ" description="A window function for FFT. WINDOW should be CONJ, HAMMING, or RECTANGLE."/>
      <Parameter name="WINDOW_LENGTH" type="subnet_param" value="WLENGTH" description="The length of the window."/>
    </Node>
    <Node name="node_DisplayLocalization_1" type="DisplayLocalization" x="265.000000" y="-151.000000">
      <Parameter name="WINDOW_LENGTH" type="int" value="1000" description="Window length to show at the same time [sample]"/>
    </Node>
    <Link from="node_WhiteNoiseAdder_1" output="OUTPUT" to="node_MelFilterBank_1" input="INPUT"/>
    <Link from="node_SpectralMeanNormalization_1" output="OUTPUT" to="node_Delta_1" input="INPUT"/>
    <Link from="node_AudioStreamFromWave_1" output="AUDIO" to="node_MultiFFT_1" input="INPUT"/>
    <Link from="node_MultiFFT_1" output="OUTPUT" to="node_GHDSS_1" input="INPUT_FRAMES"/>
    <Link from="node_MultiFFT_1" output="OUTPUT" to="node_LocalizeMUSIC_1" input="INPUT">81.5 -32 115 -32 115 -63 -260 -63 -260 -102 -214.5 -102 </Link>
    <Link from="node_LocalizeMUSIC_1" output="OUTPUT" to="node_SourceTracker_1" input="INPUT"/>
    <Link from="node_SourceTracker_1" output="OUTPUT" to="node_SourceIntervalExtender_1" input="SOURCES"/>
    <Link from="node_SourceIntervalExtender_1" output="OUTPUT" to="node_GHDSS_1" input="INPUT_SOURCES">228.5 -102 257 -102 257 -62 128 -62 128 -16 146 -16.5 </Link>
    <Link from="node_GHDSS_1" output="OUTPUT" to="node_PostFilter_1" input="INPUT_SPEC">310 -24 327 -24 327 30 -34 30 -34 49 -10.5 49.5 </Link>
    <Link from="node_SourceIntervalExtender_1" output="OUTPUT" to="node_SpectralMeanNormalization_1" input="SOURCES">228.5 -102 343 -102 343 178 -332 178 -332 220 -297 220.5 </Link>
    <Link from="node_SourceIntervalExtender_1" output="OUTPUT" to="node_SpeechRecognitionClient_1" input="SOURCES">228.5 -102 343 -102 343 359 -35 359 -35 411 27 411 </Link>
    <Link from="node_BGNEstimator_1" output="NOISE_POWER" to="node_PostFilter_1" input="INIT_NOISE_POWER"/>
    <Link from="node_PowerCalcForMatrix_1" output="OUTPUT" to="node_BGNEstimator_1" input="INPUT_POWER"/>
    <Link from="node_MultiFFT_1" output="OUTPUT" to="node_PowerCalcForMatrix_1" input="INPUT">81.5 -32 99 -32 99 14 -320 14 -320 65 -302 65 </Link>
    <Link from="node_MelFilterBank_1" output="OUTPUT" to="node_MSLSExtraction_1" input="FBANK"/>
    <Link from="node_WhiteNoiseAdder_1" output="OUTPUT" to="node_MSLSExtraction_1" input="SPECTRUM">-184.5 125 -166 125 -166 154 -31 154 -31 141 2 140.5 </Link>
    <Link from="node_MSLSExtraction_1" output="OUTPUT" to="node_SpectralMeanNormalization_1" input="FBANK">185 133 217 133 217 166 -322 166 -322 206 -297 205.5 </Link>
    <Link from="node_Delta_1" output="OUTPUT" to="node_FeatureRemover_1" input="INPUT"/>
    <Link from="node_FeatureRemover_1" output="OUTPUT" to="node_SpeechRecognitionClient_1" input="FEATURES">167 213 291 213 291 337 6 337 6 381 27 381 </Link>
    <Link from="node_MelFilterBank_2" output="OUTPUT" to="node_MFMGeneration_1" input="FBANK_SS">-205 328 -190 328 -190 303 -160 303 </Link>
    <Link from="node_MelFilterBank_3" output="OUTPUT" to="node_MFMGeneration_1" input="FBANK"/>
    <Link from="node_MelFilterBank_4" output="OUTPUT" to="node_MFMGeneration_1" input="FBANK_BN">-206 370 -178 370 -178 318 -160 318 </Link>
    <Link from="node_GHDSS_1" output="OUTPUT" to="node_MelFilterBank_2" input="INPUT">310 -24 327 -24 327 30 -343 30 -343 328 -301 328 </Link>
    <Link from="node_PostFilter_1" output="EST_NOISE_POWER" to="node_MelFilterBank_4" input="INPUT">303.5 64.5 314 65 314 253 -331 253 -331 370 -302 370 </Link>
    <Link from="node_PostFilter_1" output="OUTPUT_SPEC" to="node_MelFilterBank_3" input="INPUT">303.5 49.5 327 50 327 264 -319 264 -319 288 -302 288 </Link>
    <Link from="node_MFMGeneration_1" output="OUTPUT" to="node_DeltaMask_1" input="INPUT"/>
    <Link from="node_DeltaMask_1" output="OUTPUT" to="node_DeltaPowerMask_1" input="INPUT"/>
    <Link from="node_DeltaPowerMask_1" output="OUTPUT" to="node_SpeechRecognitionClient_1" input="MASKS">253.5 303 269 303 269 348 -14 348 -14 396 27 396 </Link>
    <Link from="node_PostFilter_1" output="OUTPUT_SPEC" to="node_Synthesize_1" input="INPUT"/>
    <Link from="node_Synthesize_1" output="OUTPUT" to="node_PreEmphasis_1" input="INPUT">438.5 50 459 50 459 94 -508 95 -508 124 -494 125 </Link>
    <Link from="node_MultiFFT_2" output="OUTPUT" to="node_WhiteNoiseAdder_1" input="INPUT"/>
    <Link from="node_PreEmphasis_1" output="OUTPUT" to="node_MultiFFT_2" input="INPUT"/>
    <Link from="node_SourceIntervalExtender_1" output="OUTPUT" to="node_DisplayLocalization_1" input="SOURCES"/>
    <NetOutput name="ASR" node="node_SpeechRecognitionClient_1" terminal="OUTPUT" object_type="Vector&lt;ObjectRef&gt;" description="The same as SOURCES."/>
    <NetInput name="IN" node="node_AudioStreamFromWave_1" terminal="INPUT" object_type="Stream" description="An audio input stream (IStream)."/>
    <NetCondition name="CONDITION" node="node_AudioStreamFromWave_1" terminal="NOT_EOF"/>
    <NetOutput name="OUTPUT" node="node_DisplayLocalization_1" terminal="OUTPUT" object_type="Vector&lt;ObjectRef&gt;" description="The same as input."/>
    <Note x="0" y="0" visible="0" text="Created with FlowDesigner 0.9.1"/>
  </Network>
  <Parameter name="int:ARG4" type="" value=""/>
  <Parameter name="int:ARG5" type="" value=""/>
  <Parameter name="int:ARG6" type="" value=""/>
  <Parameter name="ARG3" type="" value=""/>
  <Parameter name="ARG2" type="" value=""/>
  <Parameter name="float:ARG7" type="" value=""/>
  <Parameter name="ARG1" type="" value=""/>
</Document>
