#!/usr/bin/env batchflow
<?xml version="1.0"?>
<Document>
  <Network type="subnet" name="MAIN">
    <Node name="node_MAIN_LOOP_1" type="MAIN_LOOP" x="145.000000" y="72.000000">
      <Parameter name="LENGTH" type="int" value="512" description="The length of a frame in one channel (in samples)."/>
      <Parameter name="ADVANCE" type="int" value="160" description="The shift length beween adjacent frames (in samples)."/>
      <Parameter name="SAMPLING_RATE" type="int" value="16000" description="Sampling Rate (Hz)."/>
      <Parameter name="GET_FRAMES" type="subnet_param" value="int:ARG1" description="Number of iteration to do (max)"/>
      <Parameter name="DOWHILE" type="bool" value="" description=""/>
    </Node>
    <NetOutput name="OUTPUT" node="node_MAIN_LOOP_1" terminal="OUTPUT" object_type="any" description="No description available"/>
    <NetOutput name="NOT_EOF" node="node_MAIN_LOOP_1" terminal="NOT_EOF" object_type="bool" description="True if we haven't reach the end of file yet."/>
    <Note x="0" y="0" visible="0" text="Created with FlowDesigner 0.9.1"/>
  </Network>
  <Network type="iterator" name="MAIN_LOOP">
    <Node name="node_AudioStreamFromMic_1" type="AudioStreamFromMic" x="-174.000000" y="69.000000">
      <Parameter name="LENGTH" type="subnet_param" value="LENGTH" description="The length of a frame in one channel (in samples)."/>
      <Parameter name="ADVANCE" type="subnet_param" value="ADVANCE" description="The shift length beween adjacent frames (in samples)."/>
      <Parameter name="CHANNEL_COUNT" type="int" value="16" description="The number of channels."/>
      <Parameter name="SAMPLING_RATE" type="subnet_param" value="SAMPLING_RATE" description="Sampling rate (Hz)."/>
      <Parameter name="DEVICETYPE" type="string" value="WS" description="Device type (ASIO, ALSA, RASP, or WS)."/>
      <Parameter name="DEVICE" type="string" value="192.168.33.211" description="The name of device."/>
    </Node>
    <Node name="node_ChannelSelector_1" type="ChannelSelector" x="98.000000" y="62.000000">
      <Parameter name="SELECTOR" type="object" value="&lt;Vector&lt;int&gt; 0 1 2 8 9 10 11 &gt;" description="Flags for channel selection. When the first three channels are selected from four channels, the flags should be set to &lt;Vector&lt;int&gt; 0 1 2&gt;."/>
    </Node>
    <Node name="node_MatrixToMap_1" type="MatrixToMap" x="-162.000000" y="148.000000"/>
    <Node name="node_Iterate_1" type="Iterate" x="-113.000000" y="13.000000">
      <Parameter name="MAX_ITER" type="subnet_param" value="GET_FRAMES" description="Number of iteration to do (max)"/>
    </Node>
    <Node name="node_SaveRawPCM_1" type="SaveRawPCM" x="31.000000" y="148.000000">
      <Parameter name="BASENAME" type="string" value="ch_" description="Basename of saved raw PCM files."/>
      <Parameter name="ADVANCE" type="subnet_param" value="ADVANCE" description="The shift length between adjacent frames."/>
      <Parameter name="BITS" type="int" value="16" description="Bit format of samples. 16 and 24 bits are supported."/>
    </Node>
    <Link from="node_AudioStreamFromMic_1" output="AUDIO" to="node_ChannelSelector_1" input="INPUT"/>
    <Link from="node_ChannelSelector_1" output="OUTPUT" to="node_MatrixToMap_1" input="INPUT">154 62 183 62 183 118 -250 118 -250 148 -208 148 </Link>
    <Link from="node_MatrixToMap_1" output="OUTPUT" to="node_SaveRawPCM_1" input="INPUT"/>
    <NetCondition name="CONDITION" node="node_Iterate_1" terminal="OUTPUT"/>
    <NetOutput name="NOT_EOF" node="node_AudioStreamFromMic_1" terminal="NOT_EOF" object_type="bool" description="True if we haven't reach the end of file yet."/>
    <NetOutput name="OUTPUT" node="node_SaveRawPCM_1" terminal="OUTPUT" object_type="Map&lt;int,ObjectRef&gt;" description="The same as input."/>
    <Note x="0" y="0" visible="0" text="Created with FlowDesigner 0.9.1"/>
  </Network>
  <Parameter name="int:ARG1" type="" value=""/>
</Document>
